Index: /LMDZ5/branches/testing/libf/phylmd/ocean_slab_mod.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/ocean_slab_mod.F90	(revision 2668)
+++ /LMDZ5/branches/testing/libf/phylmd/ocean_slab_mod.F90	(revision 2669)
@@ -9,4 +9,6 @@
   USE indice_sol_mod
   USE surface_data
+  USE mod_grid_phy_lmdz, ONLY: klon_glo
+  USE mod_phys_lmdz_mpi_data, ONLY: is_mpi_root
 
   IMPLICIT NONE
@@ -14,43 +16,68 @@
   PUBLIC :: ocean_slab_init, ocean_slab_frac, ocean_slab_noice, ocean_slab_ice
 
-!****************************************************************************************
+!***********************************************************************************
 ! Global saved variables
-!****************************************************************************************
-
+!***********************************************************************************
+  ! number of slab vertical layers
+  INTEGER, PUBLIC, SAVE :: nslay
+  !$OMP THREADPRIVATE(nslay)
+  ! timestep for coupling (update slab temperature) in timesteps
   INTEGER, PRIVATE, SAVE                           :: cpl_pas
   !$OMP THREADPRIVATE(cpl_pas)
+  ! cyang = 1/heat capacity of top layer (rho.c.H)
   REAL, PRIVATE, SAVE                              :: cyang
   !$OMP THREADPRIVATE(cyang)
+  ! depth of slab layers (1 or 2)
   REAL, ALLOCATABLE, DIMENSION(:), PRIVATE, SAVE   :: slabh
   !$OMP THREADPRIVATE(slabh)
+  ! slab temperature
   REAL, ALLOCATABLE, DIMENSION(:,:), PUBLIC, SAVE   :: tslab
   !$OMP THREADPRIVATE(tslab)
+  ! heat flux convergence due to Ekman
+  REAL, ALLOCATABLE, DIMENSION(:,:), PUBLIC, SAVE   :: dt_ekman
+  !$OMP THREADPRIVATE(dt_ekman)
+  ! heat flux convergence due to horiz diffusion
+  REAL, ALLOCATABLE, DIMENSION(:,:), PUBLIC, SAVE   :: dt_hdiff
+  !$OMP THREADPRIVATE(dt_hdiff)
+  ! fraction of ocean covered by sea ice (sic / (oce+sic))
   REAL, ALLOCATABLE, DIMENSION(:), PUBLIC, SAVE  :: fsic
   !$OMP THREADPRIVATE(fsic)
+  ! temperature of the sea ice
   REAL, ALLOCATABLE, DIMENSION(:), PUBLIC, SAVE  :: tice
   !$OMP THREADPRIVATE(tice)
+  ! sea ice thickness, in kg/m2
   REAL, ALLOCATABLE, DIMENSION(:), PUBLIC, SAVE  :: seaice
   !$OMP THREADPRIVATE(seaice)
+  ! net surface heat flux, weighted by open ocean fraction
   REAL, ALLOCATABLE, DIMENSION(:), PUBLIC, SAVE  :: slab_bils
   !$OMP THREADPRIVATE(slab_bils)
+  ! slab_bils accumulated over cpl_pas timesteps
   REAL, ALLOCATABLE, DIMENSION(:), PRIVATE, SAVE  :: bils_cum
   !$OMP THREADPRIVATE(bils_cum)
+  ! net heat flux into the ocean below the ice : conduction + solar radiation
   REAL, ALLOCATABLE, DIMENSION(:), PUBLIC, SAVE  :: slab_bilg
   !$OMP THREADPRIVATE(slab_bilg)
+  ! slab_bilg over cpl_pas timesteps
   REAL, ALLOCATABLE, DIMENSION(:), PRIVATE, SAVE  :: bilg_cum
   !$OMP THREADPRIVATE(bilg_cum)
-
-!****************************************************************************************
+  ! wind stress saved over cpl_pas timesteps
+  REAL, ALLOCATABLE, DIMENSION(:), PRIVATE, SAVE  :: taux_cum
+  !$OMP THREADPRIVATE(taux_cum)
+  REAL, ALLOCATABLE, DIMENSION(:), PRIVATE, SAVE  :: tauy_cum
+  !$OMP THREADPRIVATE(tauy_cum)
+
+!***********************************************************************************
 ! Parameters (could be read in def file: move to slab_init)
-!****************************************************************************************
+!***********************************************************************************
 ! snow and ice physical characteristics:
     REAL, PARAMETER :: t_freeze=271.35 ! freezing sea water temp
     REAL, PARAMETER :: t_melt=273.15   ! melting ice temp
     REAL, PARAMETER :: sno_den=300. !mean snow density, kg/m3
-    REAL, PARAMETER :: ice_den=917.
-    REAL, PARAMETER :: sea_den=1025.
-    REAL, PARAMETER :: ice_cond=2.17*ice_den !conductivity
-    REAL, PARAMETER :: sno_cond=0.31*sno_den
+    REAL, PARAMETER :: ice_den=917. ! ice density
+    REAL, PARAMETER :: sea_den=1025. ! sea water density
+    REAL, PARAMETER :: ice_cond=2.17*ice_den !conductivity of ice
+    REAL, PARAMETER :: sno_cond=0.31*sno_den ! conductivity of snow
     REAL, PARAMETER :: ice_cap=2067.   ! specific heat capacity, snow and ice
+    REAL, PARAMETER :: sea_cap=3995.   ! specific heat capacity, snow and ice
     REAL, PARAMETER :: ice_lat=334000. ! freeze /melt latent heat snow and ice
 
@@ -74,36 +101,90 @@
     REAL, PARAMETER :: alb_ice_dry=0.75 !dry thick ice
     REAL, PARAMETER :: alb_ice_wet=0.66 !melting thick ice
-    REAL, PARAMETER :: pen_frac=0.3 !fraction of penetrating shortwave (no snow)
+    REAL, PARAMETER :: pen_frac=0.3 !fraction of shortwave penetrating into the
+    ! ice (no snow)
     REAL, PARAMETER :: pen_ext=1.5 !extinction of penetrating shortwave (m-1)
 
-!****************************************************************************************
+! horizontal transport
+   LOGICAL, PUBLIC, SAVE :: slab_hdiff
+   !$OMP THREADPRIVATE(slab_hdiff)
+   REAL, PRIVATE, SAVE    :: coef_hdiff ! coefficient for horizontal diffusion
+   !$OMP THREADPRIVATE(coef_hdiff)
+   INTEGER, PUBLIC, SAVE :: slab_ekman, slab_cadj ! Ekman, conv adjustment
+   !$OMP THREADPRIVATE(slab_ekman)
+   !$OMP THREADPRIVATE(slab_cadj)
+
+!***********************************************************************************
 
 CONTAINS
 !
-!****************************************************************************************
+!***********************************************************************************
 !
   SUBROUTINE ocean_slab_init(dtime, pctsrf_rst)
   !, seaice_rst etc
 
-    use IOIPSL
-
-    ! For ok_xxx vars (Ekman...)
-    INCLUDE "clesphys.h"
+    USE ioipsl_getin_p_mod, ONLY : getin_p
+    USE mod_phys_lmdz_transfert_para, ONLY : gather
+    USE slab_heat_transp_mod, ONLY : ini_slab_transp
 
     ! Input variables
-!****************************************************************************************
+!***********************************************************************************
     REAL, INTENT(IN)                         :: dtime
 ! Variables read from restart file
-    REAL, DIMENSION(klon, nbsrf), INTENT(IN) :: pctsrf_rst
+    REAL, DIMENSION(klon, nbsrf), INTENT(IN) :: pctsrf_rst 
+    ! surface fractions from start file
 
 ! Local variables
-!****************************************************************************************
+!************************************************************************************
     INTEGER                :: error
+    REAL, DIMENSION(klon_glo) :: zmasq_glo
     CHARACTER (len = 80)   :: abort_message
     CHARACTER (len = 20)   :: modname = 'ocean_slab_intit'
 
-!****************************************************************************************
+!***********************************************************************************
+! Define some parameters
+!***********************************************************************************
+! Number of slab layers
+    nslay=2
+    CALL getin_p('slab_layers',nslay)
+    print *,'number of slab layers : ',nslay
+! Layer thickness
+    ALLOCATE(slabh(nslay), stat = error)
+    IF (error /= 0) THEN
+       abort_message='Pb allocation slabh'
+       CALL abort_physic(modname,abort_message,1)
+    ENDIF
+    slabh(1)=50.
+    IF (nslay.GT.1) THEN 
+        slabh(2)=150.
+    END IF
+
+! cyang = 1/heat capacity of top layer (rho.c.H)
+    cyang=1/(slabh(1)*sea_den*sea_cap)
+
+! cpl_pas  coupling period (update of tslab and ice fraction)
+! pour un calcul a chaque pas de temps, cpl_pas=1
+    cpl_pas = NINT(86400./dtime * 1.0) ! une fois par jour
+    CALL getin_p('cpl_pas',cpl_pas)
+    print *,'cpl_pas',cpl_pas
+
+! Horizontal diffusion
+    slab_hdiff=.FALSE.
+    CALL getin_p('slab_hdiff',slab_hdiff)
+    coef_hdiff=25000.
+    CALL getin_p('coef_hdiff',coef_hdiff)
+! Ekman transport
+    slab_ekman=0
+    CALL getin_p('slab_ekman',slab_ekman)
+! Convective adjustment
+    IF (nslay.EQ.1) THEN
+        slab_cadj=0
+    ELSE
+        slab_cadj=1
+    END IF
+    CALL getin_p('slab_cadj',slab_cadj)
+
+!************************************************************************************
 ! Allocate surface fraction read from restart file
-!****************************************************************************************
+!************************************************************************************
     ALLOCATE(fsic(klon), stat = error)
     IF (error /= 0) THEN
@@ -112,11 +193,12 @@
     ENDIF
     fsic(:)=0.
+    !zmasq = continent fraction
     WHERE (1.-zmasq(:)>EPSFRA)
         fsic(:) = pctsrf_rst(:,is_sic)/(1.-zmasq(:))
     END WHERE
 
-!****************************************************************************************
-! Allocate saved variables
-!****************************************************************************************
+!************************************************************************************
+! Allocate saved fields
+!************************************************************************************
     ALLOCATE(tslab(klon,nslay), stat=error)
        IF (error /= 0) CALL abort_physic &
@@ -136,5 +218,5 @@
     bils_cum(:) = 0.0   
 
-    IF (version_ocean=='sicINT') THEN
+    IF (version_ocean=='sicINT') THEN ! interactive sea ice
         ALLOCATE(slab_bilg(klon), stat = error)
         IF (error /= 0) THEN
@@ -161,55 +243,69 @@
     END IF
 
-!****************************************************************************************
-! Define some parameters
-!****************************************************************************************
-! Layer thickness
-    ALLOCATE(slabh(nslay), stat = error)
-    IF (error /= 0) THEN
-       abort_message='Pb allocation slabh'
-       CALL abort_physic(modname,abort_message,1)
+    IF (slab_hdiff) THEN !horizontal diffusion
+        ALLOCATE(dt_hdiff(klon,nslay), stat = error)
+        IF (error /= 0) THEN
+           abort_message='Pb allocation dt_hdiff'
+           CALL abort_physic(modname,abort_message,1)
+        ENDIF
+        dt_hdiff(:,:) = 0.0   
     ENDIF
-    slabh(1)=50.
-! cyang = 1/heat capacity of top layer (rho.c.H)
-    cyang=1/(slabh(1)*4.228e+06)
-
-! cpl_pas periode de couplage avec slab (update tslab, pctsrf)
-! pour un calcul à chaque pas de temps, cpl_pas=1
-    cpl_pas = NINT(86400./dtime * 1.0) ! une fois par jour
-    CALL getin('cpl_pas',cpl_pas)
-    print *,'cpl_pas',cpl_pas
+
+    IF (slab_ekman.GT.0) THEN ! ekman transport
+        ALLOCATE(dt_ekman(klon,nslay), stat = error)
+        IF (error /= 0) THEN
+           abort_message='Pb allocation dt_ekman'
+           CALL abort_physic(modname,abort_message,1)
+        ENDIF
+        dt_ekman(:,:) = 0.0   
+        ALLOCATE(taux_cum(klon), stat = error)
+        IF (error /= 0) THEN
+           abort_message='Pb allocation taux_cum'
+           CALL abort_physic(modname,abort_message,1)
+        ENDIF
+        taux_cum(:) = 0.0   
+        ALLOCATE(tauy_cum(klon), stat = error)
+        IF (error /= 0) THEN
+           abort_message='Pb allocation tauy_cum'
+           CALL abort_physic(modname,abort_message,1)
+        ENDIF
+        tauy_cum(:) = 0.0   
+    ENDIF
+
+! Initialize transport
+    IF (slab_hdiff.OR.(slab_ekman.GT.0)) THEN
+      CALL gather(zmasq,zmasq_glo)
+!$OMP MASTER  ! Only master thread
+      IF (is_mpi_root) THEN 
+          CALL ini_slab_transp(zmasq_glo)
+      END IF
+!$OMP END MASTER
+    END IF
 
  END SUBROUTINE ocean_slab_init
 !
-!****************************************************************************************
+!***********************************************************************************
 !
   SUBROUTINE ocean_slab_frac(itime, dtime, jour, pctsrf_chg, is_modified)
 
-    USE limit_read_mod
-
-!    INCLUDE "clesphys.h"
+! this routine sends back the sea ice and ocean fraction to the main physics
+! routine. Called only with interactive sea ice
 
 ! Arguments
-!****************************************************************************************
-    INTEGER, INTENT(IN)                        :: itime   ! numero du pas de temps courant
-    INTEGER, INTENT(IN)                        :: jour    ! jour a lire dans l'annee
-    REAL   , INTENT(IN)                        :: dtime   ! pas de temps de la physique (en s)
+!************************************************************************************
+    INTEGER, INTENT(IN)                        :: itime   ! current timestep 
+    INTEGER, INTENT(IN)                        :: jour    !  day in year (not 
+    REAL   , INTENT(IN)                        :: dtime   ! physics timestep (s)
     REAL, DIMENSION(klon,nbsrf), INTENT(INOUT) :: pctsrf_chg  ! sub-surface fraction
-    LOGICAL, INTENT(OUT)                       :: is_modified ! true if pctsrf is modified at this time step
-
-! Local variables
-!****************************************************************************************
-
-    IF (version_ocean == 'sicOBS'.OR. version_ocean == 'sicNO') THEN   
-       CALL limit_read_frac(itime, dtime, jour, pctsrf_chg, is_modified)
-    ELSE
+    LOGICAL, INTENT(OUT)                       :: is_modified ! true if pctsrf is 
+                                                         ! modified at this time step
+
        pctsrf_chg(:,is_oce)=(1.-fsic(:))*(1.-zmasq(:))
        pctsrf_chg(:,is_sic)=fsic(:)*(1.-zmasq(:))
        is_modified=.TRUE.
-    END IF
 
   END SUBROUTINE ocean_slab_frac
 !
-!****************************************************************************************
+!************************************************************************************
 !
   SUBROUTINE ocean_slab_noice( & 
@@ -224,58 +320,83 @@
     
     USE calcul_fluxs_mod
+    USE slab_heat_transp_mod, ONLY: divgrad_phy, slab_ekman1, slab_ekman2
+    USE mod_phys_lmdz_para
 
     INCLUDE "clesphys.h"
 
+! This routine 
+! (1) computes surface turbulent fluxes over points with some open ocean    
+! (2) reads additional Q-flux (everywhere)
+! (3) computes horizontal transport (diffusion & Ekman)
+! (4) updates slab temperature every cpl_pas ; creates new ice if needed.
+
+! Note : 
+! klon total number of points
+! knon number of points with open ocean (varies with time)
+! knindex gives position of the knon points within klon.
+! In general, local saved variables have klon values
+! variables exchanged with PBL module have knon.
+
 ! Input arguments
-!****************************************************************************************
-    INTEGER, INTENT(IN)                  :: itime
-    INTEGER, INTENT(IN)                  :: jour
-    INTEGER, INTENT(IN)                  :: knon
-    INTEGER, DIMENSION(klon), INTENT(IN) :: knindex
-    REAL, INTENT(IN)                     :: dtime
-    REAL, DIMENSION(klon), INTENT(IN)    :: p1lay
-    REAL, DIMENSION(klon), INTENT(IN)    :: cdragh, cdragq, cdragm
-    REAL, DIMENSION(klon), INTENT(IN)    :: precip_rain, precip_snow
-    REAL, DIMENSION(klon), INTENT(IN)    :: temp_air, spechum
-    REAL, DIMENSION(klon), INTENT(IN)    :: AcoefH, AcoefQ, BcoefH, BcoefQ
-    REAL, DIMENSION(klon), INTENT(IN)    :: AcoefU, AcoefV, BcoefU, BcoefV
-    REAL, DIMENSION(klon), INTENT(IN)    :: ps
-    REAL, DIMENSION(klon), INTENT(IN)    :: u1, v1, gustiness
-    REAL, DIMENSION(klon), INTENT(IN)    :: tsurf_in
-    REAL, DIMENSION(klon), INTENT(INOUT) :: radsol
+!***********************************************************************************
+    INTEGER, INTENT(IN)                  :: itime ! current timestep INTEGER,
+    INTEGER, INTENT(IN)                  :: jour  ! day in year (for Q-Flux) 
+    INTEGER, INTENT(IN)                  :: knon  ! number of points 
+    INTEGER, DIMENSION(klon), INTENT(IN) :: knindex 
+    REAL, INTENT(IN) :: dtime  ! timestep (s)
+    REAL, DIMENSION(klon), INTENT(IN)    :: p1lay 
+    REAL, DIMENSION(klon), INTENT(IN)    :: cdragh, cdragq, cdragm 
+    ! drag coefficients
+    REAL, DIMENSION(klon), INTENT(IN)    :: precip_rain, precip_snow 
+    REAL, DIMENSION(klon), INTENT(IN)    :: temp_air, spechum ! near surface T, q
+    REAL, DIMENSION(klon), INTENT(IN)    :: AcoefH, AcoefQ, BcoefH, BcoefQ 
+    REAL, DIMENSION(klon), INTENT(IN)    :: AcoefU, AcoefV, BcoefU, BcoefV 
+    ! exchange coefficients for boundary layer scheme
+    REAL, DIMENSION(klon), INTENT(IN)    :: ps  ! surface pressure
+    REAL, DIMENSION(klon), INTENT(IN)    :: u1, v1, gustiness ! surface wind
+    REAL, DIMENSION(klon), INTENT(IN)    :: tsurf_in ! surface temperature
+    REAL, DIMENSION(klon), INTENT(INOUT) :: radsol ! net surface radiative flux
 
 ! In/Output arguments
-!****************************************************************************************
-    REAL, DIMENSION(klon), INTENT(INOUT) :: snow
+!************************************************************************************
+    REAL, DIMENSION(klon), INTENT(INOUT) :: snow ! in kg/m2
     
 ! Output arguments
-!****************************************************************************************
+!************************************************************************************
     REAL, DIMENSION(klon), INTENT(OUT)   :: qsurf
     REAL, DIMENSION(klon), INTENT(OUT)   :: evap, fluxsens, fluxlat
     REAL, DIMENSION(klon), INTENT(OUT)   :: flux_u1, flux_v1
-    REAL, DIMENSION(klon), INTENT(OUT)   :: tsurf_new
+    REAL, DIMENSION(klon), INTENT(OUT)   :: tsurf_new ! new surface tempearture
     REAL, DIMENSION(klon), INTENT(OUT)   :: dflux_s, dflux_l      
     REAL, DIMENSION(klon), INTENT(OUT)   :: qflux
 
 ! Local variables
-!****************************************************************************************
-    INTEGER               :: i,ki
-    ! surface fluxes
+!************************************************************************************
+    INTEGER               :: i,ki,k
+    REAL                  :: t_cadj
+    !  for surface heat fluxes
     REAL, DIMENSION(klon) :: cal, beta, dif_grnd
-    ! flux correction
+    ! for Q-Flux computation: d/dt SST, d/dt ice volume (kg/m2), surf fluxes 
     REAL, DIMENSION(klon) :: diff_sst, diff_siv, lmt_bils
-    ! surface wind stress
+    ! for surface wind stress
     REAL, DIMENSION(klon) :: u0, v0
     REAL, DIMENSION(klon) :: u1_lay, v1_lay
-    ! ice creation
+    ! for new ice creation
     REAL                  :: e_freeze, h_new, dfsic
-
-!****************************************************************************************
-! 1) Flux calculation
-!
-!****************************************************************************************
-    cal(:)      = 0.
-    beta(:)     = 1.
-    dif_grnd(:) = 0.
+    ! horizontal diffusion and Ekman local vars
+    ! dimension = global domain (klon_glo) instead of // subdomains 
+    REAL, DIMENSION(klon_glo,nslay) :: dt_hdiff_glo, dt_ekman_glo
+    ! dt_ekman_glo saved for diagnostic, dt_ekman_tmp used for time loop
+    REAL, DIMENSION(klon_glo,nslay) :: dt_hdiff_tmp, dt_ekman_tmp
+    REAL, DIMENSION(klon_glo,nslay) :: tslab_glo
+    REAL, DIMENSION(klon_glo) :: taux_glo,tauy_glo
+
+!****************************************************************************************
+! 1) Surface fluxes calculation
+!    
+!****************************************************************************************
+    cal(:)      = 0. ! infinite thermal inertia
+    beta(:)     = 1. ! wet surface
+    dif_grnd(:) = 0. ! no diffusion into ground
     
 ! Suppose zero surface speed
@@ -285,4 +406,5 @@
     v1_lay(:) = v1(:) - v0(:)
 
+! Compute latent & sensible fluxes
     CALL calcul_fluxs(knon, is_oce, dtime, &
          tsurf_in, p1lay, cal, beta, cdragh, cdragq, ps, &
@@ -292,12 +414,6 @@
          tsurf_new, evap, fluxlat, fluxsens, dflux_s, dflux_l)
 
-! - Flux calculation at first modele level for U and V
-    CALL calcul_flux_wind(knon, dtime, &
-         u0, v0, u1, v1, gustiness, cdragm, &
-         AcoefU, AcoefV, BcoefU, BcoefV, &
-         p1lay, temp_air, &
-         flux_u1, flux_v1)  
-
-! Accumulate total fluxes locally
+! save total cumulated heat fluxes locally
+! radiative + turbulent + melt of falling snow 
     slab_bils(:)=0.
     DO i=1,knon
@@ -306,13 +422,28 @@
                       -precip_snow(i)*ice_lat*(1.+snow_wfact*fsic(ki)))
         bils_cum(ki)=bils_cum(ki)+slab_bils(ki)
-! Also taux, tauy, saved vars...
     END DO
 
-!****************************************************************************************
-! 2) Get global variables lmt_bils and diff_sst from file limit_slab.nc
+!  Compute surface wind stress
+    CALL calcul_flux_wind(knon, dtime, &
+         u0, v0, u1, v1, gustiness, cdragm, &
+         AcoefU, AcoefV, BcoefU, BcoefV, &
+         p1lay, temp_air, &
+         flux_u1, flux_v1)  
+
+! save cumulated wind stress
+    IF (slab_ekman.GT.0) THEN 
+      DO i=1,knon
+          ki=knindex(i)
+          taux_cum(ki)=taux_cum(ki)+flux_u1(i)*(1.-fsic(ki))/cpl_pas
+          tauy_cum(ki)=tauy_cum(ki)+flux_v1(i)*(1.-fsic(ki))/cpl_pas
+      END DO
+    ENDIF
+
+!****************************************************************************************
+! 2) Q-Flux : get global variables lmt_bils, diff_sst and diff_siv from file limit_slab.nc
 !
 !****************************************************************************************
     lmt_bils(:)=0.
-    CALL limit_slab(itime, dtime, jour, lmt_bils, diff_sst, diff_siv) ! global pour un processus
+    CALL limit_slab(itime, dtime, jour, lmt_bils, diff_sst, diff_siv) 
     ! lmt_bils and diff_sst,siv saved by limit_slab
     qflux(:)=lmt_bils(:)+diff_sst(:)/cyang/86400.-diff_siv(:)*ice_den*ice_lat/86400.
@@ -320,71 +451,160 @@
 
 !****************************************************************************************
-! 3) Recalculate new temperature
-!
+! 3) Recalculate new temperature (add Surf fluxes, Q-Flux, Ocean transport)
+!    Bring to freezing temp and make sea ice if necessary
+!  
 !***********************************************o*****************************************
     tsurf_new=tsurf_in
     IF (MOD(itime,cpl_pas).EQ.0) THEN ! time to update tslab & fraction
-        ! Compute transport
-        ! Add read QFlux and SST tendency
-        tslab(:,1)=tslab(:,1)+qflux(:)*cyang*dtime*cpl_pas 
-        ! Add cumulated surface fluxes
-        tslab(:,1)=tslab(:,1)+bils_cum(:)*cyang*dtime
-        ! Update surface temperature
-        SELECT CASE(version_ocean)
-        CASE('sicNO')
-            DO i=1,knon
-                ki=knindex(i)
-                tsurf_new(i)=tslab(ki,1)
+! ***********************************
+!  Horizontal transport 
+! ***********************************
+      IF (slab_ekman.GT.0) THEN 
+          ! copy wind stress to global var
+          CALL gather(taux_cum,taux_glo)
+          CALL gather(tauy_cum,tauy_glo)
+      END IF
+
+      IF (slab_hdiff.OR.(slab_ekman.GT.0)) THEN 
+        CALL gather(tslab,tslab_glo)
+      ! Compute horiz transport on one process only
+!$OMP MASTER  ! Only master thread
+        IF (is_mpi_root) THEN ! Only master processus          
+          IF (slab_hdiff) THEN 
+              dt_hdiff_glo(:,:)=0.
+          END IF
+          IF (slab_ekman.GT.0) THEN 
+              dt_ekman_glo(:,:)=0.
+          END IF
+          DO i=1,cpl_pas ! time splitting for numerical stability
+            IF (slab_ekman.GT.0) THEN
+              SELECT CASE (slab_ekman)
+                CASE (1)
+                  CALL slab_ekman1(taux_glo,tauy_glo,tslab_glo,dt_ekman_tmp)
+                CASE (2)
+                  CALL slab_ekman2(taux_glo,tauy_glo,tslab_glo,dt_ekman_tmp)
+                CASE DEFAULT
+                  dt_ekman_tmp(:,:)=0.
+              END SELECT
+              dt_ekman_glo(:,:)=dt_ekman_glo(:,:)+dt_ekman_tmp(:,:)
+              ! convert dt_ekman from K.s-1.(kg.m-2) to K.s-1   
+              DO k=1,nslay
+                dt_ekman_tmp(:,k)=dt_ekman_tmp(:,k)/(slabh(k)*sea_den)
+              ENDDO
+              tslab_glo=tslab_glo+dt_ekman_tmp*dtime
+            ENDIF
+            IF (slab_hdiff) THEN ! horizontal diffusion
+              ! laplacian of slab T
+              CALL divgrad_phy(nslay,tslab_glo,dt_hdiff_tmp)
+              ! multiply by diff coef and normalize to 50m slab equivalent
+              dt_hdiff_tmp=dt_hdiff_tmp*coef_hdiff*50./SUM(slabh)
+              dt_hdiff_glo(:,:)=dt_hdiff_glo(:,:)+ dt_hdiff_tmp(:,:)
+              tslab_glo=tslab_glo+dt_hdiff_tmp*dtime
+            END IF
+          END DO ! time splitting
+          IF (slab_hdiff) THEN
+            !dt_hdiff_glo saved in W/m2
+            DO k=1,nslay
+              dt_hdiff_glo(:,k)=dt_hdiff_glo(:,k)*slabh(k)*sea_den*sea_cap/cpl_pas
             END DO
-        CASE('sicOBS') ! check for sea ice or tslab below freezing
-            DO i=1,knon
-                ki=knindex(i)
-                IF ((tslab(ki,1).LT.t_freeze).OR.(fsic(ki).GT.epsfra)) THEN
-                    tslab(ki,1)=t_freeze
-                END IF
-                tsurf_new(i)=tslab(ki,1)
-            END DO
-        CASE('sicINT')
-            DO i=1,knon
-                ki=knindex(i)
-                IF (fsic(ki).LT.epsfra) THEN ! Free of ice
-                    IF (tslab(ki,1).LT.t_freeze) THEN ! create new ice
-                        ! quantity of new ice formed
-                        e_freeze=(t_freeze-tslab(ki,1))/cyang/ice_lat
-                        ! new ice
-                        tice(ki)=t_freeze
-                        fsic(ki)=MIN(ice_frac_max,e_freeze/h_ice_thin)
-                        IF (fsic(ki).GT.ice_frac_min) THEN
-                            seaice(ki)=MIN(e_freeze/fsic(ki),h_ice_max)
-                            tslab(ki,1)=t_freeze
-                        ELSE
-                            fsic(ki)=0.
-                        END IF
-                        tsurf_new(i)=t_freeze
-                    ELSE
-                        tsurf_new(i)=tslab(ki,1)
-                    END IF 
-                ELSE ! ice present
-                    tsurf_new(i)=t_freeze
-                    IF (tslab(ki,1).LT.t_freeze) THEN ! create new ice
-                        ! quantity of new ice formed over open ocean
-                        e_freeze=(t_freeze-tslab(ki,1))/cyang*(1.-fsic(ki)) &
-                                 /(ice_lat+ice_cap/2.*(t_freeze-tice(ki)))
-                        ! new ice height and fraction
-                        h_new=MIN(h_ice_new,seaice(ki)) ! max new height ice_new
-                        dfsic=MIN(ice_frac_max-fsic(ki),e_freeze/h_new)
-                        h_new=MIN(e_freeze/dfsic,h_ice_max)
-                        ! update tslab to freezing over open ocean only
-                        tslab(ki,1)=tslab(ki,1)*fsic(ki)+t_freeze*(1.-fsic(ki))
-                        ! update sea ice
-                        seaice(ki)=(h_new*dfsic+seaice(ki)*fsic(ki)) &
-                                   /(dfsic+fsic(ki))
-                        fsic(ki)=fsic(ki)+dfsic
-                        ! update snow?
-                    END IF !freezing
-                END IF ! sea ice present
-            END DO
-        END SELECT
-        bils_cum(:)=0.0! clear cumulated fluxes
+          END IF
+          IF (slab_ekman.GT.0) THEN 
+            ! dt_ekman_glo saved in W/m2
+            dt_ekman_glo(:,:)=dt_ekman_glo(:,:)*sea_cap/cpl_pas
+          END IF
+        END IF ! is_mpi_root
+!$OMP END MASTER
+!$OMP BARRIER
+        ! Send new fields back to all processes
+        CALL Scatter(tslab_glo,tslab)
+        IF (slab_hdiff) THEN
+          CALL Scatter(dt_hdiff_glo,dt_hdiff)
+        END IF
+        IF (slab_ekman.GT.0) THEN 
+          CALL Scatter(dt_ekman_glo,dt_ekman)
+          ! clear wind stress
+          taux_cum(:)=0.
+          tauy_cum(:)=0.
+        END IF
+      ENDIF ! transport
+
+! ***********************************
+! Other heat fluxes
+! ***********************************
+      ! Add read QFlux
+      tslab(:,1)=tslab(:,1)+qflux(:)*cyang*dtime*cpl_pas 
+      ! Add cumulated surface fluxes
+      tslab(:,1)=tslab(:,1)+bils_cum(:)*cyang*dtime
+      ! Convective adjustment if 2 layers 
+      IF ((nslay.GT.1).AND.(slab_cadj.GT.0)) THEN
+        DO i=1,klon
+          IF (tslab(i,2).GT.tslab(i,1)) THEN
+            ! mean (mass-weighted) temperature
+            t_cadj=SUM(tslab(i,:)*slabh(:))/SUM(slabh(:))
+            tslab(i,1)=t_cadj
+            tslab(i,2)=t_cadj
+          END IF
+        END DO
+      END IF
+! ***********************************
+! Update surface temperature and ice 
+! ***********************************
+      SELECT CASE(version_ocean)
+      CASE('sicNO') ! no sea ice even below freezing !
+          DO i=1,knon
+              ki=knindex(i)
+              tsurf_new(i)=tslab(ki,1)
+          END DO
+      CASE('sicOBS') ! "realistic" case, for prescribed sea ice
+        ! tslab cannot be below freezing, or above it if there is sea ice
+          DO i=1,knon
+              ki=knindex(i)
+              IF ((tslab(ki,1).LT.t_freeze).OR.(fsic(ki).GT.epsfra)) THEN
+                  tslab(ki,1)=t_freeze
+              END IF
+              tsurf_new(i)=tslab(ki,1)
+          END DO
+      CASE('sicINT') ! interactive sea ice
+          DO i=1,knon
+              ki=knindex(i)
+              IF (fsic(ki).LT.epsfra) THEN ! Free of ice
+                  IF (tslab(ki,1).LT.t_freeze) THEN ! create new ice
+                      ! quantity of new ice formed
+                      e_freeze=(t_freeze-tslab(ki,1))/cyang/ice_lat
+                      ! new ice
+                      tice(ki)=t_freeze
+                      fsic(ki)=MIN(ice_frac_max,e_freeze/h_ice_thin)
+                      IF (fsic(ki).GT.ice_frac_min) THEN
+                          seaice(ki)=MIN(e_freeze/fsic(ki),h_ice_max)
+                          tslab(ki,1)=t_freeze
+                      ELSE
+                          fsic(ki)=0.
+                      END IF
+                      tsurf_new(i)=t_freeze
+                  ELSE
+                      tsurf_new(i)=tslab(ki,1)
+                  END IF 
+              ELSE ! ice present
+                  tsurf_new(i)=t_freeze
+                  IF (tslab(ki,1).LT.t_freeze) THEN ! create new ice
+                      ! quantity of new ice formed over open ocean
+                      e_freeze=(t_freeze-tslab(ki,1))/cyang*(1.-fsic(ki)) &
+                               /(ice_lat+ice_cap/2.*(t_freeze-tice(ki)))
+                      ! new ice height and fraction
+                      h_new=MIN(h_ice_new,seaice(ki)) ! max new height ice_new
+                      dfsic=MIN(ice_frac_max-fsic(ki),e_freeze/h_new)
+                      h_new=MIN(e_freeze/dfsic,h_ice_max)
+                      ! update tslab to freezing over open ocean only
+                      tslab(ki,1)=tslab(ki,1)*fsic(ki)+t_freeze*(1.-fsic(ki))
+                      ! update sea ice
+                      seaice(ki)=(h_new*dfsic+seaice(ki)*fsic(ki)) &
+                                 /(dfsic+fsic(ki))
+                      fsic(ki)=fsic(ki)+dfsic
+                      ! update snow?
+                  END IF ! tslab below freezing
+              END IF ! sea ice present
+          END DO
+      END SELECT
+      bils_cum(:)=0.0! clear cumulated fluxes
     END IF ! coupling time
   END SUBROUTINE ocean_slab_noice
@@ -530,7 +750,7 @@
            seaice(ki) = MAX(0.0,seaice(ki)-(evap(i)-snow_evap)*dtime)
         ENDIF
-! Melt / Freeze from above if Tsurf>0
+! Melt / Freeze snow from above if Tsurf>0
         IF (tsurf_new(i).GT.t_melt) THEN
-            ! energy available for melting snow (in kg/m2 of snow)
+            ! energy available for melting snow (in kg of melted snow /m2)
             e_melt = MIN(MAX(snow(i)*(tsurf_new(i)-t_melt)*ice_cap/2. &
                /(ice_lat+ice_cap/2.*(t_melt-tice(ki))),0.0),snow(i))
